/*

 Copyright (C) 2008  Alejandro Gutierrez Munoz

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <iostream>
#include <string>
#include <vector>

using namespace std;

class graph
{
public:

	typedef vector< vector< float > > graphCurrents;

	graph(void);
	graph(const string&);

	string getGraphName(void) const {return graph_name;};
	string getGraphClass(void) const {return graph_class;};

	string exportDOTstring(void) const;

	~graph(void);

private:

	typedef struct vertex {	
		int id;
		string label;
	};

	typedef struct listnode {	
		int id;
		string value;
	};

	string graph_name;
	string graph_class;
	vector< vertex > vertices;
	vector< vector< listnode > > adjacency_list;

};
